﻿; Keybord Assistent - расширение раскладки клавиатуры
; Версия 1.5 от 2022 г.
; Автор версии 1.5: Крутов А.Ю.; e-mail: kaiu@mail.ru; site: kaiu.narod.ru
; ( версию программы не забываем менять на строке Menu, tray, Tip )
; некоторые части скрипта заимствованы с форума http://forum.script-coding.com
; ( для справки используйте так же и сайт https://ahk-wiki.ru/ )

; ===   ИЗМЕНЕНИЯ В ВЕРСИИ 1.5   ========================
; Так как переключение языка в ворд 2016 приводило к его зависанию, то 
; механизм его был переработан.
; чуть изменения коснулись транслитерации (добавлены некоторые символы)
; изменена немного иконка, теперь там буквы KA - сокращение от Keybord Assistent
; изменено меню и теперь из него можно убрать подсказку, которая как раз и глючила в ворд 2016
; можно задать озвучивание переключения языков (+звук для удержаний и переключений CAPSLOCK)
; все изменения в настройке сохраняются в локальном файле «setting.ini»
; меню можно переключить на 4 языка и от этого зависит какой рисунок справки вам будет показан
; 

; ===   ИЗМЕНЕНИЯ В ВЕРСИИ 1.4   ========================
; Alt+Shift+ScrollLock транслит для имен файлов чуть изменен, особо это касается замену запятой и сдвоенных __ на _ И другое ( ищи код if(replSpace) )
; Alt+Win+ScrollLock транслит молдавской кирилицы в румынскую латиницу
; Alt+Pause в нижний регистр (Alt+Shift+Pause - в верхний)
; подправлено под измененную раскладку Бирмана версии 3.7, кроме знака Apple

; ===   ИЗМЕНЕНИЯ В ВЕРСИИ 1.3   ========================
; Добавлен короткий пробел и узкий неразрывный пробел


; ===   ОПИСАНИЕ ДЛЯ ПЕРЕКЛЮЧЕНИЯ ЯЗЫКОВ   ========================
; На примере 4 языков: русский (основной), английский, украинский, белорусский
;   показана возможность переключения раскладок
; С помощью программы "KeyTweak" назначаем правому ALt значение "WWW Stop"
; С помощью программы "KeyTweak" назначаем правому Win значение "My Computer"
;   (или с помощью запуска файла "Переназначить RAlt RWin.reg" и потом перегружаем компьютер)
; Переключение всегда в русский по быстрому нажатию и отжатию левого Shift (LShift)
; Переключение всегда в английский по быстрому нажатию и отжатию правого Shift (RShift)
; Быстрое переключение русский-английский по быстрому нажатию и отжатию на правый Alt (RAlt)
; Переключение между другими языками (не RU и не EN) левый Alt+пробел
; ===   ОПИСАНИЕ ДЛЯ РАСШИРЕНИЕ РАСКЛАДКИ   =======================
; Отключается правый Alt (RAlt) - основная рабочая клавиша
; Отключается правый Win - будет для расширения раскладки Ильи Бирмана
; Переназначается CapsLock - будет работать как левый Ctrl (LCtrl)
;   а переключать CapsLock по быстрому нажатию на обе кнопки Shift
; Переназначается правый Ctrl - будет работать как правый Alt (оставлен для возможностей национальных раскладок)
; Левый Alt+"ё", +"5", +"6", +"8", +"-", +"=", +"\" используются, так что учитывайте если такие комбинации есть в ваших программах.
; Многое подробнее показано на рисунке (на иконке скрипта клик правой кнопкой мыши и выбрать пункт меню Справка)
; Транслитерация выделенного текста по Alt+ScrollLock
;   Alt+Shift+ScrollLock транслит для имён файлов
; Вставка текста без форматирования по Ctrl+Alt+V
; Блокирование компьютера будет только по Wil+L (а не Ctrl+Alt+Del и выбор пункта меню)
; Остановка скрипта (по меню трея скрипта "Стоп\Запустить") возвращает все системные настройки и даже RAlt и RWin

; =================================================================
; =======   ПЕРЕКЛЮЧЕНИЕ ЯЗЫКОВ   =================================
; =================================================================

#MaxThreads 200
#SingleInstance ; запуск только одной копии.

PLanguage:="RU" ; язык меню
IniRead, var, setting.ini, MAIN, PLanguage
if( var <> "ERROR" )
{
	PLanguage := var
}
else
{
	IniWrite, %PLanguage%, setting.ini, MAIN, PLanguage
}

	
PProcesses:="WINWORD.EXE;TOTALCMD.EXE"
IniRead, var, setting.ini, SWITCH_PROBLEM_PROCESSES_IN_ANOTHER_WAY, PProcesses
if( var <> "ERROR" )
{
	PProcesses := var	
}
else
{
	IniWrite, %PProcesses%, setting.ini, SWITCH_PROBLEM_PROCESSES_IN_ANOTHER_WAY, PProcesses
}
PProcesses := StrSplit(PProcesses, ";") ; в виде массива храним

 

PerCheckLng:=0 ; менять ли языки или время на это вышло
PerCheckCapsLock:=0 ; менять ли CapsLock или время на это вышло
PerRasklUp:=1 ; был ли уже Up переключения раскладки
PerShiftUp:=1 ; был ли уже ShiftUp
OldLng:=check_lang() ; прошлый язык для переключения в текущий
OldLng2:="" ; прошлый язык для переключения между RU и EN

EnToolTip:=1 ; разрешена ли сплывающая подсказка
EnSoundBeep:=0 ; разрешен ли звук
LvSoundBeep:=30 ; уровень звука
DSoundBeep:=150 ; длительность звука
HSoundBeep:=0 ; частота звука для проигрывания


; ------ к расширению раскладки ------------------------------------
vmBeg:=2 ; скорость перемещения курсора мыши начальная
vm:=vmBeg ; скорость перемещения курсора мыши
pmN:=0 ; направление перемещения курсора мыши (1-вправо,2-влево,3-вниз,4-вверх)
pmNOLD:=0 ; предыдущее значение переменной (для быстрого перехода к краям)
plav:=0 ; плавность перемещения курсора мыши
timePAdd:=150 ; период увеличения
timeUpdPer:=30 ; обновление перемещения
MouseClDownL=0; режим удержания клика на левой кнопке мыши
MouseClDownR=0; режим удержания клика на правой кнопке мыши


gosub LoadMenu
gosub LoadIni

; закрыть данный скрипт возвращающий RAlt RWin если он будет запущен
process, exist, RAltRWin.exe
pid = %ErrorLevel%
Process, Close, %pid%

; запретить Win+L для блокировки ( ! но разрешено будет с помощью горячей клавиши LWin+L )
SetDisableLockWorkstationRegKeyValue( 1 ) 

; подпрограмма выполняемая при завершении скрипта
OnExit, OnExitSub

;vkA9::return ; на RAlt закомментил так как переключает языки EN-RU
vkB6::return ; на RWin
RCtrl::RAlt ; правый контр станет правым альтом
; CapsLock работает как левый контрл, а возможность переключение CapsLock будет по быстрому нажатию на обе кнопки Shift
CapsLock::LCtrl 

vkA9 & Tab::return
LAlt & vkA9::return



LoadMenu:
	if(PLanguage = "RU")
	{
		Menu, MySubmenu, Add, тихо
		Menu, MySubmenu, Check, тихо
		Menu, MySubmenu, Add, средне
		Menu, MySubmenu, Uncheck, средне
		Menu, MySubmenu, Add, громко
		Menu, MySubmenu, Uncheck, громко
		
		Menu, LgSubmenu, Add, RU 
		Menu, LgSubmenu, Check, RU 
		Menu, LgSubmenu, Add, EN 
		Menu, LgSubmenu, Uncheck, EN 
		Menu, LgSubmenu, Add, UK 
		Menu, LgSubmenu, Uncheck, UK 
		Menu, LgSubmenu, Add, BE 
		Menu, LgSubmenu, Uncheck, BE

		Menu, tray, icon, KeybAs.ico ; иконка скрипта
		Menu, tray, NoStandard
		Menu, tray, Add, Выйти
		Menu, tray, Add	
		Menu, tray, Add, Проблема? 	
		Menu, tray, Add, Перезагрузить
		Menu, tray, Add	
		Menu, tray, Add, Показывать_подсказку 
		Menu, tray, Check, Показывать_подсказку 
		Menu, tray, Add, Озвучить_переключение_языков 
		Menu, tray, Add, Уровень_звука_при_запуске, :MySubmenu
		Menu, tray, Add, Language, :LgSubmenu
		Menu, tray, Add	
		Menu, tray, Add, Справка
		Menu, tray, Add
		Menu, tray, Add, Стоп\Запустить
		Menu, tray, Tip, Расширение раскладки клавиатуры (Hot key) 1.5.0.2 Автор: kaiu.narod.ru
	}
	else if(PLanguage = "EN")
	{
		Menu, MySubmenu, Add, quiet
		Menu, MySubmenu, Check, quiet
		Menu, MySubmenu, Add, medium
		Menu, MySubmenu, Uncheck, medium
		Menu, MySubmenu, Add, loudly
		Menu, MySubmenu, Uncheck, loudly
		
		Menu, LgSubmenu, Add, RU 
		Menu, LgSubmenu, Check, RU 
		Menu, LgSubmenu, Add, EN 
		Menu, LgSubmenu, Uncheck, EN 
		Menu, LgSubmenu, Add, UK 
		Menu, LgSubmenu, Uncheck, UK 
		Menu, LgSubmenu, Add, BE 
		Menu, LgSubmenu, Uncheck, BE

		Menu, tray, icon, KeybAs.ico ; иконка скрипта
		Menu, tray, NoStandard
		Menu, tray, Add, Exit
		Menu, tray, Add	
		Menu, tray, Add, Problem?
		Menu, tray, Add, Reload
		Menu, tray, Add	
		Menu, tray, Add, Show_tooltip 
		Menu, tray, Check, Show_tooltip 
		Menu, tray, Add, Voice_language_switching 
		Menu, tray, Add, Sound_level_at_startup, :MySubmenu
		Menu, tray, Add, Language, :LgSubmenu
		Menu, tray, Add	
		Menu, tray, Add, Help
		Menu, tray, Add
		Menu, tray, Add, Stop\Start
		Menu, tray, Tip, Keyboard layout extension (Hot key) 1.5.0.2 Author: kaiu.narod.ru

	}
	else if(PLanguage = "UK")
	{
		Menu, MySubmenu, Add, тихо
		Menu, MySubmenu, Check, тихо
		Menu, MySubmenu, Add, середньо
		Menu, MySubmenu, Uncheck, середньо
		Menu, MySubmenu, Add, голосно
		Menu, MySubmenu, Uncheck, голосно
		
		Menu, LgSubmenu, Add, RU 
		Menu, LgSubmenu, Check, RU 
		Menu, LgSubmenu, Add, EN 
		Menu, LgSubmenu, Uncheck, EN 
		Menu, LgSubmenu, Add, UK 
		Menu, LgSubmenu, Uncheck, UK 
		Menu, LgSubmenu, Add, BE 
		Menu, LgSubmenu, Uncheck, BE

		Menu, tray, icon, KeybAs.ico ; иконка скрипта
		Menu, tray, NoStandard
		Menu, tray, Add, Вийти
		Menu, tray, Add	
		Menu, tray, Add, Проблема?
		Menu, tray, Add, Перезавантажити
		Menu, tray, Add	
		Menu, tray, Add, Показувати_підказку 
		Menu, tray, Check, Показувати_підказку 
		Menu, tray, Add, Озвучити_перемикання_мов 
		Menu, tray, Add, Рівень_звуку_під_час_запуску, :MySubmenu
		Menu, tray, Add, Language, :LgSubmenu
		Menu, tray, Add	
		Menu, tray, Add, Довідка
		Menu, tray, Add
		Menu, tray, Add, Стоп\Запустити
		Menu, tray, Tip, Розширення розкладки клавіатури (Hot key) 1.5.0.2 Автор: kaiu.narod.ru
	}
	else if(PLanguage = "BE")
	{
		Menu, MySubmenu, Add, ціха
		Menu, MySubmenu, Check, ціха
		Menu, MySubmenu, Add, сярэдне
		Menu, MySubmenu, Uncheck, сярэдне
		Menu, MySubmenu, Add, гучна
		Menu, MySubmenu, Uncheck, гучна
		
		Menu, LgSubmenu, Add, RU 
		Menu, LgSubmenu, Check, RU 
		Menu, LgSubmenu, Add, EN 
		Menu, LgSubmenu, Uncheck, EN 
		Menu, LgSubmenu, Add, UK 
		Menu, LgSubmenu, Uncheck, UK 
		Menu, LgSubmenu, Add, BE 
		Menu, LgSubmenu, Uncheck, BE

		Menu, tray, icon, KeybAs.ico ; иконка скрипта
		Menu, tray, NoStandard
		Menu, tray, Add, Выйсці
		Menu, tray, Add	
		Menu, tray, Add, Праблема?
		Menu, tray, Add, Перазагрузіць
		Menu, tray, Add	
		Menu, tray, Add, Паказваць_падказку 
		Menu, tray, Check, Паказваць_падказку 
		Menu, tray, Add, Агучыць_пераключэнне_моў
		Menu, tray, Add, Узровень_гуку_пры_запуску, :MySubmenu
		Menu, tray, Add, Language, :LgSubmenu
		Menu, tray, Add	
		Menu, tray, Add, Даведка
		Menu, tray, Add
		Menu, tray, Add, Стоп\Запусціць
		Menu, tray, Tip, Пашырэнне раскладкі клавіятуры (Hot key) 1.5.0.2 Аўтар: kaiu.narod.ru
	}

return


LoadIni:
	IniRead, var, setting.ini, MAIN, PLanguage 
	if( var <> "ERROR" )
	{	
		PLanguage := var
			
		if(PLanguage = "RU")	
		{
			Menu, LgSubmenu, Check, RU 	
			Menu, LgSubmenu, Uncheck, EN 		
			Menu, LgSubmenu, Uncheck, UK 		
			Menu, LgSubmenu, Uncheck, BE 
		}
		else if(PLanguage = "EN")
		{
			Menu, LgSubmenu, Uncheck, RU 	
			Menu, LgSubmenu, Check, EN 		
			Menu, LgSubmenu, Uncheck, UK 		
			Menu, LgSubmenu, Uncheck, BE 
		}	
		else if(PLanguage = "UK")
		{
			Menu, LgSubmenu, Uncheck, RU 	
			Menu, LgSubmenu, Uncheck, EN 		
			Menu, LgSubmenu, Check, UK 		
			Menu, LgSubmenu, Uncheck, BE 
		}
		else if(PLanguage = "BE")
		{
			Menu, LgSubmenu, Uncheck, RU 	
			Menu, LgSubmenu, Uncheck, EN 		
			Menu, LgSubmenu, Uncheck, UK 		
			Menu, LgSubmenu, Check, BE 
		}	
	}


	IniRead, var, setting.ini, MAIN, PEnToolTip 
	if( var <> "ERROR" )
	{	
		if(var = 0)	
		{
			EnToolTip := 1
		}
		else 
		{
			EnToolTip := 0
		}	
		gosub, Показывать_подсказку 	
	}

	IniRead, var, setting.ini, MAIN, PDSoundBeep 
	if( var <> "ERROR" )
	{
		DSoundBeep := var ; пропишите сами в setting.ini если вам нужна особая длительность 	
	}

	IniRead, var, setting.ini, MAIN, PLvSoundBeep 
	if( var <> "ERROR" )
	{
		LvSoundBeep := var
		if( LvSoundBeep = 30 )
		{
			gosub, тихо 
		}
		else if( LvSoundBeep = 50 )
		{
			gosub, средне 
		} 
		else if( LvSoundBeep = 70 )
		{
			gosub, громко 
		}
		else
		{
			SoundSet, LvSoundBeep
		}		
	}

	IniRead, var, setting.ini, MAIN, PEnSoundBeep 
	if( var <> "ERROR" )
	{
		if(var = 0)	
		{
			EnSoundBeep := 1
		}
		else 
		{
			EnSoundBeep := 0
		}	
		gosub, Озвучить_переключение_языков	 	
	}
return



RU:
	PLanguage = "RU"
	IniWrite, %PLanguage%, setting.ini, MAIN, PLanguage
	Sleep 100
	Reload
return
	
EN:
	PLanguage = "EN"
	IniWrite, %PLanguage%, setting.ini, MAIN, PLanguage
	Sleep 100
	Reload
return

UK:
	PLanguage = "UK"
	IniWrite, %PLanguage%, setting.ini, MAIN, PLanguage
	Reload
return

BE:
	PLanguage = "BE"
	IniWrite, %PLanguage%, setting.ini, MAIN, PLanguage
	Sleep 100
	Reload
return

; === ПОДДЕРЖКА НЕСКОЛЬКИХ ЯЗЫКОВ В МЕНЮ === 
ціха:
quiet:
тихо:
	if(PLanguage = "RU")
	{
		Menu, MySubmenu, Check, тихо
		Menu, MySubmenu, Uncheck, средне
		Menu, MySubmenu, Uncheck, громко 
	}
	else if(PLanguage = "EN")
	{
		Menu, MySubmenu, Check, quiet
		Menu, MySubmenu, Uncheck, medium
		Menu, MySubmenu, Uncheck, loudly
	}
	else if(PLanguage = "UK")
	{
		Menu, MySubmenu, Check, тихо
		Menu, MySubmenu, Uncheck, середньо
		Menu, MySubmenu, Uncheck, голосно
	}
	else if(PLanguage = "BE")
	{
		Menu, MySubmenu, Check, ціха
		Menu, MySubmenu, Uncheck, сярэдне
		Menu, MySubmenu, Uncheck, гучна
	}
	
	LvSoundBeep := 30
	SoundSet, LvSoundBeep
	IniWrite, %LvSoundBeep%, setting.ini, MAIN, PLvSoundBeep
return

сярэдне:
середньо:
medium:
средне:
	if(PLanguage = "RU")
	{
		Menu, MySubmenu, Uncheck, тихо
		Menu, MySubmenu, Check, средне
		Menu, MySubmenu, Uncheck, громко 
	}
	else if(PLanguage = "EN")
	{
		Menu, MySubmenu, Uncheck, quiet
		Menu, MySubmenu, Check, medium
		Menu, MySubmenu, Uncheck, loudly
	}
	else if(PLanguage = "UK")
	{
		Menu, MySubmenu, Uncheck, тихо
		Menu, MySubmenu, Check, середньо
		Menu, MySubmenu, Uncheck, голосно
	}
	else if(PLanguage = "BE")
	{
		Menu, MySubmenu, Uncheck, ціха
		Menu, MySubmenu, Check, сярэдне
		Menu, MySubmenu, Uncheck, гучна
	}
	
	LvSoundBeep := 50
	SoundSet, LvSoundBeep
	IniWrite, %LvSoundBeep%, setting.ini, MAIN, PLvSoundBeep	
return

гучна:
голосно:
loudly:
громко:
	if(PLanguage = "RU")
	{
		Menu, MySubmenu, Uncheck, тихо
		Menu, MySubmenu, Uncheck, средне
		Menu, MySubmenu, Check, громко 
	}
	else if(PLanguage = "EN")
	{
		Menu, MySubmenu, Uncheck, quiet
		Menu, MySubmenu, Uncheck, medium
		Menu, MySubmenu, Check, loudly
	}
	else if(PLanguage = "UK")
	{
		Menu, MySubmenu, Uncheck, тихо
		Menu, MySubmenu, Uncheck, середньо
		Menu, MySubmenu, Check, голосно
	}
	else if(PLanguage = "BE")
	{
		Menu, MySubmenu, Uncheck, ціха
		Menu, MySubmenu, Uncheck, сярэдне
		Menu, MySubmenu, Check, гучна
	}
	
	LvSoundBeep := 70
	SoundSet, LvSoundBeep
	IniWrite, %LvSoundBeep%, setting.ini, MAIN, PLvSoundBeep
return

Выйсці:
Вийти:
Exit:
Выйти:		
	ExitApp
return


Праблема?:
Problem?:
Проблема?:
	Run, open "Help.txt"	
return

Перазагрузіць:
Перезавантажити:
Reload:
Перезагрузить:
	Reload
return

Паказваць_падказку:
Показувати_підказку:
Show_tooltip:
Показывать_подсказку:
	if( EnToolTip )
	{
		EnToolTip := 0
		IniWrite, %EnToolTip%, setting.ini, MAIN, PEnToolTip
		if(PLanguage = "RU")
		{
			Menu, tray, Uncheck, Показывать_подсказку 
		}
		else if(PLanguage = "EN")
		{
			Menu, tray, Uncheck, Show_tooltip
		}
		else if(PLanguage = "UK")
		{
			Menu, tray, Uncheck, Показувати_підказку
		}
		else if(PLanguage = "BE")
		{
			Menu, tray, Uncheck, Паказваць_падказку
		}		
	}
	else
	{
		EnToolTip := 1
		IniWrite, %EnToolTip%, setting.ini, MAIN, PEnToolTip
		if(PLanguage = "RU")
		{
			Menu, tray, Check, Показывать_подсказку 
		}
		else if(PLanguage = "EN")
		{
			Menu, tray, Check, Show_tooltip
		}
		else if(PLanguage = "UK")
		{
			Menu, tray, Check, Показувати_підказку
		}
		else if(PLanguage = "BE")
		{
			Menu, tray, Check, Паказваць_падказку
		}		
	}
return

Агучыць_пераключэнне_моў:
Озвучити_перемикання_мов:
Voice_language_switching:
Озвучить_переключение_языков:
	if( EnSoundBeep )
	{
		EnSoundBeep := 0
		IniWrite, %EnSoundBeep%, setting.ini, MAIN, PEnSoundBeep
		if(PLanguage = "RU")
		{
			Menu, tray, Uncheck, Озвучить_переключение_языков 
		}
		else if(PLanguage = "EN")
		{
			Menu, tray, Uncheck, Voice_language_switching
		}
		else if(PLanguage = "UK")
		{
			Menu, tray, Uncheck, Озвучити_перемикання_мов
		}
		else if(PLanguage = "BE")
		{
			Menu, tray, Uncheck, Агучыць_пераключэнне_моў
		}
	}
	else
	{
		EnSoundBeep := 1
		IniWrite, %EnSoundBeep%, setting.ini, MAIN, PEnSoundBeep
		if(PLanguage = "RU")
		{
			Menu, tray, Check, Озвучить_переключение_языков 
		}
		else if(PLanguage = "EN")
		{
			Menu, tray, Check, Voice_language_switching
		}
		else if(PLanguage = "UK")
		{
			Menu, tray, Check, Озвучити_перемикання_мов
		}
		else if(PLanguage = "BE")
		{
			Menu, tray, Check, Агучыць_пераключэнне_моў
		}
		SoundSet, LvSoundBeep
	}
return

Даведка:
Довідка:
Help:
Справка:
	Run, open "HelpKeybAs_%PLanguage%.jpg"	
return

Стоп\Запусціць:
Стоп\Запустити:
Stop\Start:
Стоп\Запустить:
	Suspend Toggle
	if A_IsPaused 
	{
		SetDisableLockWorkstationRegKeyValue( 1 ) ; запретить Win+L для блокировки
		; закрыть данный скрипт возвращающий RAlt RWin если он будет запущен
		process, exist, RAltRWin.exe
		pid = %ErrorLevel%
		Process, Close, %pid%
		Pause Toggle
	}	
	else
	{
		SetDisableLockWorkstationRegKeyValue( 0 ) ; разрешить Win+L для блокировки
		; запустить данный скрипт возвращающий RAlt RWin
		Run, RAltRWin.exe
		Pause Toggle				
	}
return



; подпрограмма выполняемая при завершении скрипта
OnExitSub:	
	SetDisableLockWorkstationRegKeyValue( 0 ) ; разрешить Win+L для блокировки

	; закрыть данный скрипт возвращающий RAlt RWin если он будет запущен
	process, exist, RAltRWin.exe
	pid = %ErrorLevel%
	Process, Close, %pid%
	ExitApp
return


SetDisableLockWorkstationRegKeyValue( value )
{
	RegWrite, REG_DWORD, HKEY_CURRENT_USER, Software\Microsoft\Windows\CurrentVersion\Policies\System, DisableLockWorkstation, %value%
}


; блокировка компа (нужно чтобы не было проблем с LWin+RAlt+L что приводило к зависанию LAlt после блокировки)
LWin & l::
	if Not A_IsPaused
	{
		SetDisableLockWorkstationRegKeyValue( 0 ) ; разрешить Win+L для блокировки
		Sleep 200
		DllCall("LockWorkStation")
		Suspend Toggle
		Pause Toggle
	}
	else
	{
		SetDisableLockWorkstationRegKeyValue( 0 ) ; разрешить Win+L для блокировки
		Sleep 200
		DllCall("LockWorkStation")
	}
return


vkA9 & Tab Up::
	SetTimer, TimerMoveU, off
	SetTimer, TimerVAdd, off	
	pmN:=0
	vm:=0
	
	if MouseClDownL=1 
		Click, Up
	if MouseClDownR=1
		Click, Up, Right
	if( (MouseClDownL=1) or (MouseClDownR=1) )
	{
		kbd_msg("Удержание отключено")
		if( EnSoundBeep )
		{
			SoundBeep, 175, 90 ;  фа0 175
		}
	}
	MouseClDownL=0 ; режим удержания клика на левой кнопке мыши
	MouseClDownR=0 ; режим удержания клика на правой кнопке мыши
return


vkA9 & u Up::
vkA9 & o Up::
vkA9 & i Up::
vkA9 & k Up::
vkA9 & j Up::
vkA9 & l Up::
	SetTimer, TimerMoveU, off
	SetTimer, TimerVAdd, off	
	pmN:=0
	vm:=0
return
; ----------------------------------------------------------------------

; отдельно через таймер, так как SoundBeep в критической секции все тормозит 
TimerSoundBeep: 
	SetTimer, TimerSoundBeep, off
	if(HSoundBeep > 0)
	{
		SoundBeep, HSoundBeep, DSoundBeep
	}	
return

TimerCapsLock:
	PerCheckCapsLock := 0
	SetTimer, TimerCapsLock, off
return

TimerRaskl:
	PerCheckLng := 0
	SetTimer, TimerRaskl, off
return


TimerShift:
	PerCheckLng := 0
	SetTimer, TimerShift, off
return


~$vkA9::	
	if( PerRasklUp = 1)
	{		
		SetTimer, TimerRaskl, 200 ; время в мс на переключение раскладки
		PerCheckLng := 1	
	}
	PerRasklUp := 0	
return






; переключаем активное окно в другую раскладку по нажатию клавиши правого Alt
$vkA9 Up::			
	if( (A_PriorKey = "Browser_Stop") and (PerCheckLng=1) )
	{		
		if (not GetKeyState("Alt", "P")) and (not GetKeyState("Ctrl", "P")) and (not GetKeyState("Shift", "P")) and (not GetKeyState("Win", "P")) and (not GetKeyState("CapsLock", "P")) and (not GetKeyState("Tab", "P"))
		{				
			Lng := check_lang()
			if(Lng="RU")
			{
				switch_Lang("EN")
				OldLng2 := "EN"
			}
			else if(Lng="EN")
			{
				switch_Lang("RU")
				OldLng2 := "RU"
			}
			else
			{				
				; переключимся в ранее запомненный EN или RU
				if( (OldLng2="EN") or (OldLng2="RU") )
				{
					switch_Lang(OldLng2)
				}
				else
				{
					switch_Lang("EN")
					OldLng2 := "EN"
				}
			}
			
			
		}
	}	
	
	PerRasklUp := 1
	PerCheckLng := 0
	SetTimer, TimerRaskl, off
		
	SetKeyDelay -1
	SendInput {vkA9 Down}{vkA9 Up}
return

; переключение CapsLock будет по быстрому нажатию на обе кнопки Shift	
LShift & RShift::
RShift & LShift::
	if( PerCheckCapsLock = 1 )
	{
		PerCheckCapsLock = 2
		
		; если больше ничего не нажато
		if( (not GetKeyState("Alt", "P")) and (not GetKeyState("Ctrl", "P")) and (not GetKeyState("Win", "P"))  and (not GetKeyState("Tab", "P"))  )
		{
			SetKeyDelay 0
			SendInput {Blind}{CapsLock Down}
			Sleep 20
			SendInput {Blind}{CapsLock Up}
			
			stCL := !GetKeyState("CapsLock", "T")
			if( stCL )
			{
				kbd_msg("capslock off")
				if( EnSoundBeep )
				{
					SoundBeep, 196, 90 ; соль0 196					
				}	
			}
			else
			{
				kbd_msg("CAPS LOCK ON")	
				if( EnSoundBeep )
				{
					SoundBeep, 247, 180 ; си0 247					
				}
			}		
		}
	}
		
return


; переключаем активное окно в английскую раскладку по отжатии клавиши LShift
~$LShift::
	if( PerShiftUp = 1)
	{
		SetTimer, TimerShift, 200 ; время в мс на переключение раскладки
		PerCheckLng := 1	
	}
	PerShiftUp := 0
	
	
	
	if( PerCheckCapsLock = 0 )
	{		
		SetTimer, TimerCapsLock, 300 ; время в мс на переключение CapsLock
		PerCheckCapsLock := 1
	}	
	
	SetKeyDelay -1	
	SendInput {Blind}{LShift Down}	
return

$LShift Up::	
	PerShiftUp := 1 ; !!!!!!!!!!!!!!!!
	
	SetTimer, TimerShift, off
	SetKeyDelay -1
	SendInput {Blind}{LShift Up}	
	
	
	if (not GetKeyState("Ctrl", "P")) and (not GetKeyState("Alt", "P")) and (not GetKeyState("Win", "P")) and (not GetKeyState("CapsLock", "P")) and (not GetKeyState("Tab", "P"))
	{
		if( (A_PriorKey = "LShift") and (PerCheckLng=1) )
		{
			switch_Lang("RU")		
		}
	}	 

	PerCheckLng := 0 	
	
	
return


; переключаем активное окно в английскую раскладку по отжатии клавиши RShift
~$RShift::
	if( PerShiftUp = 1)
	{
		SetTimer, TimerShift, 200 ; время в мс на переключение раскладки
		PerCheckLng := 1	
	}
	PerShiftUp := 0
	
	
	if( PerCheckCapsLock = 0 )
	{		
		SetTimer, TimerCapsLock, 300 ; время в мс на переключение CapsLock
		PerCheckCapsLock := 1
	}
	
	
	SetKeyDelay -1
	SendInput {Blind}{RShift Down}	
return

$RShift Up::      
	if (not GetKeyState("Ctrl", "P")) and (not GetKeyState("Alt", "P")) and (not GetKeyState("Win", "P")) and (not GetKeyState("CapsLock", "P")) and (not GetKeyState("Tab", "P"))
	{
		if( (A_PriorKey = "RShift") and (PerCheckLng=1) )
		{
			switch_Lang("EN")		
		}
	}

	PerShiftUp := 1
	PerCheckLng := 0
	SetTimer, TimerShift, off	
	SetKeyDelay -1
	SendInput {Blind}{RShift Up}
return


; переключение языка
switch_Lang(lang)
{	 
	Critical ; критическая секция кода	
	
	WinGet, WinID,, A
	WinGet , WinProcessName, ProcessName, A 	
	
	global PProcesses 
	metod2:=0
	for index, value in PProcesses
	{
		if(value = WinProcessName) 
		{
			metod2 := 2 ; второй метод переключения языка
		}	
	}
		
	
	if(lang = "RU") ; для русского 
	{	
		if( metod2 = 0 )
		{
			ControlGetFocus, control, A
			PostMessage 0x50, 0, 0x4190419,%control%, A
		}
		else
		{
			PostMessage 0x50, 0, 0x4190419,, A
		}
		kbd_msg("RU")				
	} 
	else if(lang = "EN") ; для английского
	{	
		if( metod2 = 0 )
		{
			ControlGetFocus, control, A
			PostMessage 0x50, 0, 0x4090409,%control%, A
		}
		else
		{
			PostMessage 0x50, 0, 0x4090409,, A
		}
		kbd_msg("EN")		
	}	
	else if(lang = "RUмаш") ; для русской машинописи 0xF0080419  -0xFF7FBE7
	{	
		if( metod2 = 0 )
		{
			ControlGetFocus, control, A
			PostMessage 0x50, 0, 0xF0080419,%control%, A
		}
		else
		{
			PostMessage 0x50, 0, 0xF0080419,, A
		}		
		kbd_msg("RUмаш")
	}	
	else if(lang = "UK") ; для украинского 0xF0A80422 -0xF57FBDE
	{		  
		if( metod2 = 0 )
		{
			ControlGetFocus, control, A
			PostMessage 0x50, 0, 0xF0A80422,%control%, A
		}
		else
		{
			PostMessage 0x50, 0, 0xF0A80422,, A
		}
		kbd_msg("UK")
	}
	else if(lang = "BE") ; для белорусского
	{		 
		if( metod2 = 0 )
		{
			ControlGetFocus, control, A
			PostMessage 0x50, 0, 0x4230423,%control%, A
		}
		else
		{
			PostMessage 0x50, 0, 0x4230423,, A
		}		
		kbd_msg("BE")
	}	
	
	
	
	Critical OFF ; отключение критической секции
	Sleep -1 ; Critical точно отработал	
	
	global HSoundBeep
	global DSoundBeep
	global EnSoundBeep
	if( EnSoundBeep )
	{	
		if(lang = "RU") ; для русского
		{	
			HSoundBeep := 261 ; до1 261
			SetTimer, TimerSoundBeep, -30
		}    
		else if(lang = "EN") ; для английского
		{		
			HSoundBeep := 440 ; ля1 440
			SetTimer, TimerSoundBeep, -30
		}
		else if(lang = "RUмаш") ; для русской машинописи 0xF0080419  -0xFF7FBE7
		{	
			HSoundBeep := 329 ; ми1 329
			SetTimer, TimerSoundBeep, -30
		}		
		else if(lang = "UK") ; для украинского 0xF0A80422 -0xF57FBDE
		{		  
			HSoundBeep := 523 ; до2 523 
			SetTimer, TimerSoundBeep, -30
		}
		else if(lang = "BE") ; для белорусского
		{		 
			HSoundBeep := 698 ; фа2 698
			SetTimer, TimerSoundBeep, -30
		}		
	}
	return
}


; показ сообщения о раскладке
kbd_msg(text)
{
	global EnToolTip
	if( not EnToolTip ) 
	{
		return
	}
	
	ToolTip, %text%, A_CaretX + 10, A_CaretY - 20	
	SetTimer, KbdRemoveToolTip, -1000
	return
	
	KbdRemoveToolTip:
	ToolTip, "" , 0, 0	
	ToolTip	
	return
}


; возврат текущего языка из 2 символов (или более если раскладки другие)
check_lang_by_window_id(hWnd)
{	
	if !hWnd
		return
		
	WinGetClass, winClass, A
	if (winClass != "ConsoleWindowClass") || (b := SubStr(A_OSVersion, 1, 2) = "10")  {
		if b  {
			WinGet, consolePID, PID
			childConhostPID := GetCmdChildConhostPID(consolePID)
			dhw_prev := A_DetectHiddenWindows
			DetectHiddenWindows, On
			hWnd := WinExist("ahk_pid " . childConhostPID)
			DetectHiddenWindows, % dhw_prev
		}
		threadId := DllCall("GetWindowThreadProcessId", Ptr, hWnd, UInt, 0)
		lyt := DllCall("GetKeyboardLayout", Ptr, threadId, UInt)		
		langID := Format("{:#x}", lyt)
	}
	else ; окно консольное в вин7
	{			
		WinGet, dwProcessId, PID, A 
		bResult := DllCall("AttachConsole", "uint", dwProcessId, "int")
		if(!bResult)
		{			
			langID := 
		}
		else
		{
			VarSetCapacity(lyt, 16)
			DllCall("GetConsoleKeyboardLayoutName", Str, lyt)
			DllCall("FreeConsole")	
			langID := "0x" . lyt
		}
	}
	
; раскомментируйте если надо узнавать номер для вашей раскладки
; (не забывайте проверить и в консольном окне)
; MsgBox %langID% 		
	
	if(langID = 0x4090409) or (langID = 0x00000409) ; для английского
	{			
		return "EN"
	}
	else if(langID = 0x4190419) or (langID = 0x00000419) ; для русского
	{		
		return "RU"
	}
	else if(langID = 0xF0080419) or (langID = 0x00010419) ; русская машинопись
	{		
		return "RUмаш"
	}
	else if(langID = 0xF0A80422) or (langID = 0x00020422) ; для украинского
	{			
		return "UK" 		
	}
	else if(langID = 0x4230423) or (langID = 0x00000423) ; для белорусского
	{			
		return "BE" 		
	}
	else
	{	
		; покажет номер для другой раскладки
		return %langID%	
	}
}


GetCmdChildConhostPID(CmdPID)  {
   static TH32CS_SNAPPROCESS := 0x2, MAX_PATH := 260
   
   h := DllCall("CreateToolhelp32Snapshot", UInt, TH32CS_SNAPPROCESS, UInt, 0, Ptr)
   VarSetCapacity(PROCESSENTRY32, size := 4*7 + A_PtrSize*2 + (MAX_PATH << !!A_IsUnicode), 0)
   NumPut(size, PROCESSENTRY32, "UInt")
   res := DllCall("Process32First", Ptr, h, Ptr, &PROCESSENTRY32)
   while res  {
      parentPid := NumGet(PROCESSENTRY32, 4*4 + A_PtrSize*2, "UInt")
      if (parentPid = CmdPID)  {
         exeName := StrGet(&PROCESSENTRY32 + 4*7 + A_PtrSize*2, "CP0")
         if (exeName = "conhost.exe" && PID := NumGet(PROCESSENTRY32, 4*2, "UInt"))
            break
      }
      res := DllCall("Process32Next", Ptr, h, Ptr, &PROCESSENTRY32)
   }
   DllCall("CloseHandle", Ptr, h)
   Return PID
}


; проверка какой язык текущий
check_lang()
{
	SetFormat, Integer, H
	WinGet, WinID,, A	
	return check_lang_by_window_id( WinID ) 
}



; переключение между альтернативными языками
LAlt & Space:: 
	if ( (not GetKeyState("Ctrl", "P")) and (not GetKeyState("Shift", "P")) and (not GetKeyState("Win", "P")) and (not GetKeyState("CapsLock", "P")) and (not GetKeyState("Tab", "P")) )
	{
		; если нажат  	
		Lng := check_lang() ; текущий язык
		LngSrop := Lng
		Critical ; критическая секция кода
		Loop
		{
			; следующий язык по порядку	
			ControlGetFocus, control, A	
			SendMessage 0x50, 2,, %control%, A
			Sleep 20 
			Lng := check_lang()
			; пропускать русский и английский
			if((Lng<>"RU") and (Lng<>"EN")) or (LngSrop = Lng)
			{			
				break
			}
		}	
		Critical OFF ; отключение критической секции
		Sleep -1 ; Critical точно отработал
		
		kbd_msg(Lng)    

	}

return





; =================================================================
; =======   РАСШИРЕНИЕ РАСКЛАДКИ   ================================
; ================================================================= 


; увеличение скорости перемещения курсора мыши
TimerVAdd:	
	if pmN > 0
	{				
		if vm < 4 ; не писать имя переменной vmBeg — тормозит
			vm := 4
		else if vm <= 4
			vm := 8	
		else if vm <= 8
			vm := 16
		else if vm <= 16
			vm := 24
		else if vm <= 24
			vm := 32
		else if vm <= 32
			vm := 40
		else if vm <= 40
			vm := 56
		else if vm <= 56
			vm := 72
		else if vm <= 72
			vm := 88
		;else if vm <= 88
		;	vm := 104
			
	}
return

; перемещение указателя мыши
TimerMoveU:
	if pmN > 0
	{
		if pmN=1
			MouseMove, vm, 0, plav, Relative
		else if pmN=2
			MouseMove, -vm, 0, plav, Relative
		else if pmN=3
			MouseMove, 0, vm, plav, Relative
		else if pmN=4
			MouseMove, 0, -vm, plav, Relative	
	}
return


; =====================================
; вверх
vkA9 & i::
	GetKeyState, state, Tab, P
	if state = U
	{
		SendInput {Blind}{vkA9 Up}{Up Down}{Up Up}
	}
	else
	{
		if (pmN=0) OR (pmN<>4)
		{	
			pmN:=4
			pmNOLD:=pmN
			vm:=vmBeg				
			SetTimer, TimerVAdd, %timePAdd%
			SetTimer, TimerMoveU, %timeUpdPer%
		}	
		SendInput {Blind}{vkA9 Up}		
		MouseMove, 0, -vm, plav, Relative	
	}
return


; вниз
vkA9 & k::
	GetKeyState, state, Tab, P
	if state = U
	{
		SendInput {Blind}{vkA9 Up}{Down Down}{Down Up}
	}
	else
	{
		if (pmN=0) OR (pmN<>3)
		{	
			pmN:=3
			pmNOLD:=pmN	
			vm:=vmBeg				
			SetTimer, TimerVAdd, %timePAdd%
			SetTimer, TimerMoveU, %timeUpdPer%
		}	
		SendInput {Blind}{vkA9 Up}		
		MouseMove, 0, vm, plav, Relative	
	}
return


; влево
vkA9 & j::
	GetKeyState, state, Tab, P
	if state = U
	{
		SendInput {Blind}{vkA9 Up}{Left Down}{Left Up}
	}
	else
	{
		if (pmN=0) OR (pmN<>2)
		{	
			pmN:=2
			pmNOLD:=pmN
			vm:=vmBeg				
			SetTimer, TimerVAdd, %timePAdd%
			SetTimer, TimerMoveU, %timeUpdPer%
		}	
		SendInput {Blind}{vkA9 Up}		
		MouseMove, -vm, 0, plav, Relative	
	}
return


; вправо
vkA9 & l::
	GetKeyState, state, Tab, P
	if state = U
	{
		SendInput {Blind}{vkA9 Up}{Right Down}{Right Up}
	}
	else
	{
		if (pmN=0) OR (pmN<>1)
		{	
			pmN:=1
			pmNOLD:=pmN
			vm:=vmBeg				
			SetTimer, TimerVAdd, %timePAdd%
			SetTimer, TimerMoveU, %timeUpdPer%
		}	
		SendInput {Blind}{vkA9 Up}		
		MouseMove, vm, 0, plav, Relative
	}		
return


; в начало
vkA9 & u::
	GetKeyState, state, Tab, P
	if state = U
		SendInput {Blind}{vkA9 Up}{Home Down}{Home Up}
	else
	{
		SetTimer, TimerMoveU, off
		SetTimer, TimerVAdd, off	
		vm:=0
		pmN:=0
		if (pmNOLD=0)
		{			
			MouseMove, 40, 40, 0
		}	
		else if(pmNOLD=1)
		{
			CoordMode, Mouse, Screen 
			MouseGetPos, pzX, pzY, ,
			CoordMode, Mouse, Screen 
			MouseMove, 40, pzY, 0
		}
		else if(pmNOLD=2)
		{
			CoordMode, Mouse, Screen
			MouseGetPos, pzX, pzY, , 
			CoordMode, Mouse, Screen			
			MouseMove, A_ScreenWidth-40, pzY, 0
		}
		else if(pmNOLD=3)
		{
			CoordMode, Mouse, Screen
			MouseGetPos, pzX, pzY, , 
			CoordMode, Mouse, Screen
			MouseMove, pzX, 40, 0		
		}
		else
		{
			CoordMode, Mouse, Screen
			MouseGetPos, pzX, pzY, , 
			CoordMode, Mouse, Screen	
			MouseMove, pzX, A_ScreenHeight-40, 0	
		}	
		
		SendInput {Blind}{vkA9 Up}
	}
return


; в конец
vkA9 & o::
	GetKeyState, state, Tab, P
	if state = U
		SendInput {Blind}{vkA9 Up}{End Down}{End Up}
	else
	{
		SetTimer, TimerMoveU, off
		SetTimer, TimerVAdd, off	
		vm:=0
		pmN:=0
		if (pmNOLD=0) 
		{			
			MouseMove, A_ScreenWidth-40, 40, 0
		}			
		else if(pmNOLD=1)
		{
			CoordMode, Mouse, Screen
			MouseGetPos, pzX, pzY, , 
			CoordMode, Mouse, Screen			
			MouseMove, A_ScreenWidth-40, pzY, 0			
		}
		else if(pmNOLD=2)
		{
			CoordMode, Mouse, Screen 
			MouseGetPos, pzX, pzY, ,
			CoordMode, Mouse, Screen 
			MouseMove, 40, pzY, 0			
		}
		else if(pmNOLD=3)
		{
			
			CoordMode, Mouse, Screen
			MouseGetPos, pzX, pzY, , 
			CoordMode, Mouse, Screen	
			MouseMove, pzX, A_ScreenHeight-40, 0					
		}
		else
		{
			CoordMode, Mouse, Screen
			MouseGetPos, pzX, pzY, , 
			CoordMode, Mouse, Screen
			MouseMove, pzX, 40, 0				
		}
		SendInput {Blind}{vkA9 Up}
	}
return


; на страницу вверх или прокрутка вверх
vkA9 & p::
	GetKeyState, state, Tab, P
	if state = U
	{
		SendInput {Blind}{vkA9 Up}{PgUp Down}{PgUp Up}
	}
	else
	{
		SendInput {Blind}{vkA9 Up}
		Click, WheelUp
	}
return


; на страницу вниз или прокрутка вниз
vkA9 & vkBA::
	GetKeyState, state, Tab, P
	if state = U
	{
		SendInput {Blind}{vkA9 Up}{PgDn Down}{PgDn Up}
	}
	else
	{
		SendInput {Blind}{vkA9 Up}
		Click, WheelDown
	}
return



vkA9 & g:: ; ENTER
	SendInput {Blind}{vkA9 Up}{Enter Down}{Enter Up}	
return

vkA9 & t:: ; ESC
	SendInput {Blind}{vkA9 Up}{Escape Down}{Escape Up}	
return

vkA9 & v:: ; кнопка контекстного меню
	if MouseClDownL=1 
		Click, Up
	if MouseClDownR=1
		Click, Up, Right
	if( (MouseClDownL=1) or (MouseClDownR=1) )
	{
		kbd_msg("Удержание отключено")
		if( EnSoundBeep )
		{
			SoundBeep, 175, 90 ;  фа0 175
		}
	}
	MouseClDownL=0 ; режим удержания клика на левой кнопке мыши
	MouseClDownR=0 ; режим удержания клика на правой кнопке мыши
	SendInput {Blind}{vkA9 Up}{vk5D Down}{vk5D Up}	
return



vkA9 & s::
	SendInput {Blind}{vkA9 Up}
	Click, Middle
return

vkA9 & f::
	SendInput {Blind}{vkA9 Up}
	if MouseClDownL=1 
		Click, Up
	if MouseClDownR=1
		Click, Up, Right
	if( (MouseClDownL=1) or (MouseClDownR=1) )
	{
		kbd_msg("Удержание отключено")	
		if( EnSoundBeep )
		{
			SoundBeep, 175, 90 ;  фа0 175
		}
	}
	MouseClDownL=0 ; режим удержания клика на левой кнопке мыши
	MouseClDownR=0 ; режим удержания клика на правой кнопке мыши	
	Click
return

vkA9 & d::
	SendInput {Blind}{vkA9 Up}
	if MouseClDownL=1 
		Click, Up
	if MouseClDownR=1
		Click, Up, Right
	if( (MouseClDownL=1) or (MouseClDownR=1) )
	{
		kbd_msg("Удержание отключено")
		if( EnSoundBeep )
		{
			SoundBeep, 175, 90 ;  фа0 175
		}
	}
	MouseClDownL=0 ; режим удержания клика на левой кнопке мыши
	MouseClDownR=0 ; режим удержания клика на правой кнопке мыши	
	Click, Right
return

vkA9 & r::
	SendInput {Blind}{vkA9 Up}
	if MouseClDownL=1 
		Click, Up
	if MouseClDownR=1
		Click, Up, Right
	if( (MouseClDownL=1) or (MouseClDownR=1) )
	{
		kbd_msg("Удержание отключено")	
		if( EnSoundBeep )
		{
			SoundBeep, 175, 90 ;  фа0 175
		}
	}
	MouseClDownL=0 ; режим удержания клика на левой кнопке мыши
	MouseClDownR=0 ; режим удержания клика на правой кнопке мыши	
	Click, 2
return

vkA9 & e::
	SendInput {Blind}{vkA9 Up}
	if MouseClDownL=1 
		Click, Up
	if MouseClDownR=1
		Click, Up, Right
	if( (MouseClDownL=1) or (MouseClDownR=1) )
	{
		kbd_msg("Удержание отключено")
		if( EnSoundBeep )
		{
			SoundBeep, 175, 90 ;  фа0 175
		}
	}
	MouseClDownL=0 ; режим удержания клика на левой кнопке мыши
	MouseClDownR=0 ; режим удержания клика на правой кнопке мыши	
	Click, 2, Right
return



; послать ,и пробел или со Shift послать ;и пробел
; или режим удержания на левой кнопке мыши
vkA9 & c:: 
	GetKeyState, state, Tab, P
	if state = U
	{
		if not GetKeyState("Shift")	
		{		
			SetKeyDelay -1
			SendInput {vkA9 Up}{Text},
			SendInput {Space} 
		}	
		else ;{ASC 0059}{ASC 0032}
		{
			SetKeyDelay -1
			SendInput {vkA9 Up}{Text};
			SendInput {Space} 
		}
	}
	else
	{
		SendInput {Blind}{vkA9 Up}
		if MouseClDownR=1
			Click, Up, Right
		MouseClDownR=0 ; режим удержания клика на правой кнопке мыши

		if MouseClDownL=1
		{
			Click, Up
			MouseClDownL=0
			kbd_msg("Удержание отключено")
			if( EnSoundBeep )
			{
				SoundBeep, 175, 90 ;  фа0 175
			}
		}
		else
		{
			Click, Down
			MouseClDownL=1
			kbd_msg("Удержание левой кн. мыши")
			if( EnSoundBeep )
			{
				SoundBeep, 196, 200 ;  соль0 196
			}
		}	
	}

return




vkA9 & x:: ; (! укр. є) или режим удержания на правой кнопке мыши
	GetKeyState, state, Tab, P
	if state = U
	{
		if GetKeyState("Shift", "P") = GetKeyState("CapsLock", "T")
			SendInput {vkA9 Up}{Text}є
		else
			SendInput {vkA9 Up}{Text}Є
	}
	else
	{
		if MouseClDownL=1
			Click, Up
		MouseClDownL=0 ; режим удержания клика на левой кнопке мыши

		if MouseClDownR=1
		{
			Click, Up, Right
			MouseClDownR=0 
			kbd_msg("Удержание отключено")
			if( EnSoundBeep )
			{
				SoundBeep, 175, 90 ;  фа0 175
			}
		}
		else
		{
			Click, Down, Right
			MouseClDownR=1 
			kbd_msg("Удержание правой кн. мыши")
			if( EnSoundBeep )
			{
				SoundBeep, 220, 200 ;  ля0 220
			}
		}
	}
return




; три клавиши: PrintScreen, ScrollLock, Pause   
	vkA9 & 8::SendInput {Blind}{vkA9 Up}{PrintScreen Down}{PrintScreen Up}
	vkA9 & 9::SendInput {Blind}{vkA9 Up}{ScrollLock Down}{ScrollLock Up}
	vkA9 & 0::SendInput {Blind}{vkA9 Up}{Pause Down}{Pause Up} 
	

	
; Insert, Backspace, Delete	
	vkA9 & y::SendInput {Blind}{vkA9 Up}{Insert Down}{Insert Up}
	vkA9 & h::SendInput {Blind}{vkA9 Up}{Backspace Down}{Backspace Up}}	
	vkA9 & n::SendInput {Blind}{vkA9 Up}{Delete Down}{Delete Up}	


vkA9 & vkC0:: ; для `(ё) отправить ~ или `
	if not GetKeyState("Shift")
		SendInput {vkA9 Up}{Text}~
	else
		SendInput {vkA9 Up}{Text}``
return

vkA9 & 1:: ; для 1 отправить ! или знак градуса ° 
	if not GetKeyState("Shift")
		SendInput {vkA9 Up}{Text}!
	else
		SendInput {vkA9 Up}{Text}°
return

vkA9 & 2:: ; для 2 отправить @ или «
	if not GetKeyState("Shift")
		SendInput {vkA9 Up}{Text}@
	else
		SendInput {vkA9 Up}{Text}«
return

vkA9 & 3:: ; для 3 отправить # или »
	if not GetKeyState("Shift")
		SendInput {vkA9 Up}{Text}#
	else
		SendInput {vkA9 Up}{Text}»
return

vkA9 & 4:: ; для 4 отправить $ или знак параграфа §
	if not GetKeyState("Shift")
		SendInput {vkA9 Up}{Text}$
	else
		SendInput {vkA9 Up}{Text}§	
return

vkA9 & 5:: ; для 5 отправить % или знак промилле ‰
	if not GetKeyState("Shift")
		SendInput {vkA9 Up}{Text}`%
	else
		SendInput {vkA9 Up}{Text}‰
return

vkA9 & 6:: ; для 6 отправить ^ или знак корня √
	if not GetKeyState("Shift")
		SendInput {vkA9 Up}{Text}^
	else
		SendInput {vkA9 Up}{Text}√
return

vkA9 & 7:: ; для 7 отправить & или знак бесконечности ∞
	if not GetKeyState("Shift")
		SendInput {vkA9 Up}{Text}&
	else
		SendInput {vkA9 Up}{Text}∞		
return

vkA9 & vkBD:: ; для - отправить длинное тире — или короткое тире – 
	if not GetKeyState("Shift")
		SendInput {vkA9 Up}{Text}—
	else
		SendInput {vkA9 Up}{Text}–
return

vkA9 & vkBB:: ; для = отправить ≠ или ± 
	if not GetKeyState("Shift")
		SendInput {vkA9 Up}{Text}≠
	else
		SendInput {vkA9 Up}{Text}±
return



vkA9 & vkDC:: ; для \ отправить | или знак деления ÷ (техн. знак диапазона)
	if not GetKeyState("Shift")
		SendInput {vkA9 Up}{Text}|
	else
		SendInput {vkA9 Up}{Text}÷
return

; скобки из англ. раскладки на [, ]
vkA9 & vkDB:: 
	if not GetKeyState("Shift")
		SendInput {vkA9 Up}{Text}[
	else
		SendInput {vkA9 Up}{Text}{
return
vkA9 & vkDD:: 
	if not GetKeyState("Shift")
		SendInput {vkA9 Up}{Text}]
	else
		SendInput {vkA9 Up}{Text}}
return

; знаки <> и русские кавычки на Б,Ю
vkA9 & vkBC:: 
	if not GetKeyState("Shift")
		SendInput {vkA9 Up}{Text}<
	else
		SendInput {vkA9 Up}{Text}„
return
vkA9 & vkBE:: 
	if not GetKeyState("Shift")
		SendInput {vkA9 Up}{Text}>
	else
		SendInput {vkA9 Up}{Text}“
return

; апостроф и кавычка англ. на Э
vkA9 & vkDE:: 
	if not GetKeyState("Shift")
		SendInput {vkA9 Up}{Text}'
	else
		SendInput {vkA9 Up}{Text}"
return

; многоточие и средняя точка на русской точке (в англ /)
vkA9 & vkBF:: 
	if not GetKeyState("Shift")
		SendInput {vkA9 Up}{Text}…
	else
		SendInput {vkA9 Up}{Text}·
return

; для пробела отправить неразрывный пробел
vkA9 & vk20:: 
	if not GetKeyState("Shift")
		SendInput {vkA9 Up}{ASC 0160}
	else
		SendInput {vkA9 Up}{Text} 
return

; знак минус − на M и маркер списка •
vkA9 & m:: 
	if not GetKeyState("Shift")
		SendInput {vkA9 Up}{Text}−
	else
		SendInput {vkA9 Up}{Text}•
return



vkA9 & q:: ; (! укр. ї)
	if GetKeyState("Shift", "P") = GetKeyState("CapsLock", "T")
		SendInput {vkA9 Up}{Text}ї
	else
		SendInput {vkA9 Up}{Text}Ї
return

vkA9 & w:: ; (! молд. кирилица ӂ)
	if GetKeyState("Shift", "P") = GetKeyState("CapsLock", "T")
		SendInput {vkA9 Up}{Text}ӂ
	else
		SendInput {vkA9 Up}{Text}Ӂ
return

vkA9 & a:: ; (! бел. ў) 
	if GetKeyState("Shift", "P") = GetKeyState("CapsLock", "T")
		SendInput {vkA9 Up}{Text}ў
	else
		SendInput {vkA9 Up}{Text}Ў
return

vkA9 & z:: ; (! укр. ґ) 
	if GetKeyState("Shift", "P") = GetKeyState("CapsLock", "T")
		SendInput {vkA9 Up}{Text}ґ
	else
		SendInput {vkA9 Up}{Text}Ґ
return



vkA9 & b:: ; послать НЕ АНГЛ i (! укр. или бел.) 
	if GetKeyState("Shift", "P") = GetKeyState("CapsLock", "T")
		SendInput {vkA9 Up}{Text}і
	else
		SendInput {vkA9 Up}{Text}І
return




; ДОПОЛНЕНИЯ С ИСПОЛЬЗОВАНИЕМ ЛЕВОГО Alt
; =========================================================

; для `(ё) отправить ’ (! укр. апостроф)
LAlt & vkC0::
	SetKeyDelay 0
	if ( (not GetKeyState("Ctrl", "P")) and (not GetKeyState("Shift", "P")) and (not GetKeyState("Win", "P")) and (not GetKeyState("CapsLock", "P")) and (not GetKeyState("Tab", "P")) )
	{	
		SendInput {vkA9 Up}{Text}’
	}
	else
	{
		SendInput {Blind}{vkC0}
	}
return

; ввод евро
LAlt & 5::
	SetKeyDelay 0
	if ( (not GetKeyState("Ctrl", "P")) and (not GetKeyState("Shift", "P")) and (not GetKeyState("Win", "P")) and (not GetKeyState("CapsLock", "P")) and (not GetKeyState("Tab", "P")) )
	{	
		SendInput {vkA9 Up}{Text}€
	}
	else
	{
		SendInput {Blind}{5}
	}
return



; ввод гривны
LAlt & 6::	
	SetKeyDelay 0	
	if ( (not GetKeyState("Ctrl", "P")) and (not GetKeyState("Shift", "P")) and (not GetKeyState("Win", "P")) and (not GetKeyState("CapsLock", "P")) and (not GetKeyState("Tab", "P")) )
	{
		SendInput {vkA9 Up}{Text}₴
	}
	else
	{
		 SendInput {Blind}{6}
	}
return

; ввод рубля
LAlt & 8::
	SetKeyDelay 0
	if ( (not GetKeyState("Ctrl", "P")) and (not GetKeyState("Shift", "P")) and (not GetKeyState("Win", "P")) and (not GetKeyState("CapsLock", "P")) and (not GetKeyState("Tab", "P")) )
	{	
		SendInput {vkA9 Up}{Text}₽
	}
	else
	{
		SendInput {Blind}{8}
	}
return	
	

; ввод длинного тире с 1 (начало диалога) и 2 (тире внутри текста) пробелами
LAlt & vkBD::
	SetKeyDelay 0
	if ( (not GetKeyState("Ctrl", "P")) and (not GetKeyState("Shift", "P")) and (not GetKeyState("Win", "P")) and (not GetKeyState("CapsLock", "P")) and (not GetKeyState("Tab", "P")) )
	{	
		SendInput {Text}— 
	}
	else
	{
		SendInput {Blind}{vkBD}
	}
return 

LAlt & vkBB::
	SetKeyDelay 0
	if ( (not GetKeyState("Ctrl", "P")) and (not GetKeyState("Shift", "P")) and (not GetKeyState("Win", "P")) and (not GetKeyState("CapsLock", "P")) and (not GetKeyState("Tab", "P")) )
	{
		SendInput {vkA9 Up}{ASC 0160}{ASC 0151}{ASC 0032}
	}
	else
	{
		SendInput {Blind}{vkBB}
	}
return

LAlt & vkDC:: ; знак ударения (ставить после символа)
	SetKeyDelay 0
	if ( (not GetKeyState("Ctrl", "P")) and (not GetKeyState("Shift", "P")) and (not GetKeyState("Win", "P")) and (not GetKeyState("CapsLock", "P")) and (not GetKeyState("Tab", "P")) )
	{
		SendInput {vkA9 Up}{LAlt Up}{Text}́
	}
	else
	{
		SendInput {Blind}{vkDC}
	}
return






; RWin ДЛЯ ВОЗМОЖНОСТИ ТИПОГРАФСКОЙ РАСКЛАДКИ ИЛЬИ БИРМАНА
; смотри https://ilyabirman.ru/projects/typography-layout/
; =========================================================
vkB6 & vkC0::
	if not GetKeyState("Shift")
		SendInput {Text}₴
	else
		SendInput {Text}̀
return

vkB6 & 1::
	if not GetKeyState("Shift")
		SendInput {Text}¹		
	else
		SendInput {Text}¡
return

vkB6 & 2::
	if not GetKeyState("Shift")
		SendInput {Text}²
	else
		SendInput {Text}½
return

vkB6 & 3::
	if not GetKeyState("Shift")
		SendInput {Text}³			
	else
		SendInput {Text}⅓
return

vkB6 & 4::
	if not GetKeyState("Shift")
		SendInput {Text}$
	else
		SendInput {Text}¼
return	

vkB6 & 5::
	if not GetKeyState("Shift")
		SendInput {Text}‰
	else
		return
return	

vkB6 & 6::
	if not GetKeyState("Shift")
		SendInput {Text}↑
	else
		SendInput {Text}̂
return	

vkB6 & 7::
	if not GetKeyState("Shift")
		return
	else
		SendInput {Text}¿
return	

vkB6 & 8::
	if not GetKeyState("Shift")
		SendInput {Text}∞
	else
		return
return	

vkB6 & 9::
	if not GetKeyState("Shift")
		SendInput {Text}←
	else
		SendInput {Text}‹
return	

vkB6 & 0::
	if not GetKeyState("Shift")
		SendInput {Text}→
	else
		SendInput {Text}›
return	

; для -
vkB6 & vkBD::
	if not GetKeyState("Shift")
		SendInput {Text}—
	else
		SendInput {Text}–
return	

; для =
vkB6 & vkBB::
	if not GetKeyState("Shift")
		SendInput {Text}≠
	else
		SendInput {Text}±
return	

; для \
vkB6 & vkDC::
	if not GetKeyState("Shift")
		return
	else
		return
return	

; =========================================================
vkB6 & q::
	if not GetKeyState("Shift")
		return
	else
		SendInput {Text}̆
return	

vkB6 & w::
	if not GetKeyState("Shift")
		SendInput {Text}✓
	else
		SendInput {Text}⌃
return	

vkB6 & e::
	if not GetKeyState("Shift")
		SendInput {Text}€
	else
		SendInput {Text}⌥
return	

vkB6 & r::
	if not GetKeyState("Shift")
		SendInput {Text}®
	else
		SendInput {Text}̊
return	

vkB6 & t::
	if not GetKeyState("Shift")
		SendInput {Text}™
	else
		return
return	

vkB6 & y::
	if not GetKeyState("Shift")
		SendInput {Text}ѣ
	else
		SendInput {Text}Ѣ
return	

vkB6 & u::
	if not GetKeyState("Shift")
		SendInput {Text}ѵ
	else
		SendInput {Text}Ѵ
return	

vkB6 & i::
	if not GetKeyState("Shift")
		SendInput {Text}і
	else
		SendInput {Text}І
return	

vkB6 & o::
	if not GetKeyState("Shift")
		SendInput {Text}ѳ
	else
		SendInput {Text}Ѳ
return	

vkB6 & p::
	if not GetKeyState("Shift")
		SendInput {Text}′
	else
		SendInput {Text}″
return	

; для [
vkB6 & vkDB::
	if not GetKeyState("Shift")
		SendInput {Text}[
	else
		SendInput {Text}{
return	

; для ]
vkB6 & vkDD::
	if not GetKeyState("Shift")
		SendInput {Text}]
	else
		SendInput {Text}}
return	

; =========================================================
vkB6 & a::
	if not GetKeyState("Shift")
		SendInput {Text}≈
	else
		SendInput {Text}⌘
return	

vkB6 & s::
	if not GetKeyState("Shift")
		SendInput {Text}§
	else
		SendInput {Text}⇧
return	

vkB6 & d::
	if not GetKeyState("Shift")
		SendInput {Text}°
	else
		SendInput {Text}⌀
return	

vkB6 & f::
	if not GetKeyState("Shift")
		SendInput {Text}£
	else
		return
return	

vkB6 & g::
	if not GetKeyState("Shift")
		return
	else
		return
return	

vkB6 & h::
	if not GetKeyState("Shift")
		SendInput {Text}₽
	else
		SendInput {Text}̋
return	

vkB6 & j::
	if not GetKeyState("Shift")
		SendInput {Text}„
	else
		return

return	


vkB6 & k::	
	if not GetKeyState("Shift")
		SendInput {Text}“
	else
		SendInput {Text}‘
return	


vkB6 & l::
	if not GetKeyState("Shift")
		SendInput {Text}”		
	else	
		SendInput {Text}’
return		

; для ;
vkB6 & vkBA::
	if not GetKeyState("Shift")
		SendInput {Text}‘
	else
		SendInput {Text}̈
return	

; для '
vkB6 & vkDE::
	if not GetKeyState("Shift")
		SendInput {Text}’
	else
		return
return	

; =========================================================
vkB6 & z::
	if not GetKeyState("Shift")
		return
	else
		SendInput {Text}̧
return	


vkB6 & x::
	if not GetKeyState("Shift")
		SendInput {Text}×
	else
		SendInput {Text}·
return	

vkB6 & c::
	if not GetKeyState("Shift")
		SendInput {Text}©
	else
		SendInput {Text}¢
return	

vkB6 & v::
	if not GetKeyState("Shift")
		SendInput {Text}↓
	else
		SendInput {Text}̌
return	

vkB6 & b::
	if not GetKeyState("Shift")
		SendInput {Text}ß
	else
		SendInput {Text}ẞ
return	

vkB6 & n::
	if not GetKeyState("Shift")
		return
	else
		SendInput {Text}̃
return	

vkB6 & m::
	if not GetKeyState("Shift")
		SendInput {Text}−
	else
		SendInput {Text}•
return	

; для ,
vkB6 & vkBC::
	if not GetKeyState("Shift")
		SendInput {Text}«
	else
		SendInput {Text}„
return	

; для .
vkB6 & vkBE::
	if not GetKeyState("Shift")
		SendInput {Text}»
	else
		SendInput {Text}“
return	

; для /
vkB6 & vkBF::
	if not GetKeyState("Shift")
		SendInput {Text}…
	else
		SendInput {Text}́
return	

; для короткого пробела
vkB6 & vk20::
	SendInput {Text} 
return


; =================================================================
; =======   ТРАНСЛИТ И ДР ДОПОЛНЕНИЯ   ============================
; =================================================================

; функция транслитерации
Transliterate( x, replSpace )
{		
	StringReplace, x, x, а , a , All
    StringReplace, x, x, б , b , All
    StringReplace, x, x, в , v , All
    StringReplace, x, x, г , g , All
    StringReplace, x, x, д , d , All
    StringReplace, x, x, е , e , All
    StringReplace, x, x, ё , e , All
    StringReplace, x, x, ж , zh , All
    StringReplace, x, x, з , z , All
    StringReplace, x, x, и , i , All
    StringReplace, x, x, й , i , All
    StringReplace, x, x, к , k , All
    StringReplace, x, x, л , l , All
    StringReplace, x, x, м , m , All
    StringReplace, x, x, н , n , All
    StringReplace, x, x, о , o , All
    StringReplace, x, x, п , p , All
    StringReplace, x, x, р , r , All
    StringReplace, x, x, с , s , All
    StringReplace, x, x, т , t , All
    StringReplace, x, x, у , u , All
    StringReplace, x, x, ф , f , All
    StringReplace, x, x, х , kh , All
    StringReplace, x, x, ц , ts , All
    StringReplace, x, x, ч , ch , All
    StringReplace, x, x, ш , sh , All
    StringReplace, x, x, щ , shch , All
    StringReplace, x, x, ъ , ie , All
    StringReplace, x, x, ы , y , All
    StringReplace, x, x, ь ,   , All
    StringReplace, x, x, э , e , All
    StringReplace, x, x, ю , iu , All
    StringReplace, x, x, я , ia , All

    StringReplace, x, x, А , A , All
    StringReplace, x, x, Б , B , All
    StringReplace, x, x, В , V , All
    StringReplace, x, x, Г , G , All
    StringReplace, x, x, Д , D , All
    StringReplace, x, x, Е , E , All
    StringReplace, x, x, Ё , E , All
    StringReplace, x, x, Ж , Zh , All
    StringReplace, x, x, З , Z , All
    StringReplace, x, x, И , I , All
    StringReplace, x, x, Й , I , All
    StringReplace, x, x, К , K , All
    StringReplace, x, x, Л , L , All
    StringReplace, x, x, М , M , All
    StringReplace, x, x, Н , N , All
    StringReplace, x, x, О , O , All
    StringReplace, x, x, П , P , All
    StringReplace, x, x, Р , R , All
    StringReplace, x, x, С , S , All
    StringReplace, x, x, Т , T , All
    StringReplace, x, x, У , U , All
    StringReplace, x, x, Ф , F , All
    StringReplace, x, x, Х , Kh , All
    StringReplace, x, x, Ц , Ts , All
    StringReplace, x, x, Ч , Ch , All
    StringReplace, x, x, Ш , Sh , All
    StringReplace, x, x, Щ , Shch , All
    StringReplace, x, x, Ъ , Ie , All
    StringReplace, x, x, Ы , Y , All
    StringReplace, x, x, Ь ,   , All
    StringReplace, x, x, Э , E , All
    StringReplace, x, x, Ю , Iu , All
    StringReplace, x, x, Я , Ia , All
	
	; замена для некоторых украинских
	StringReplace, x, x, і , i , All
	StringReplace, x, x, І , I , All
	StringReplace, x, x, ї , ii , All
	StringReplace, x, x, Ї , Ii , All
	StringReplace, x, x, ґ , g , All
	StringReplace, x, x, Ґ , G , All
	StringReplace, x, x, є , ie , All
	StringReplace, x, x, Є , Ie , All
	
	; другие языки
	StringReplace, x, x, ў , w , All
	StringReplace, x, x, Ў , W , All
	StringReplace, x, x, ӂ , g , All
	StringReplace, x, x, Ӂ , G , All
	
	
	; замена пробела и др. символов для сохранения в именах файлов
	if(replSpace) 
	{
		StringReplace, x,x,%A_Space%,_, All	; пробел заменить _				
		StringReplace, x,x,№,N, All
		StringReplace, x,x,`%,, All
		StringReplace, x,x,`,,_, All
		StringReplace, x,x,!,, All
		StringReplace, x,x,?,, All
		StringReplace, x,x,~,, All
		StringReplace, x,x,/,_, All
		StringReplace, x,x,*,, All
		StringReplace, x,x,>,, All
		StringReplace, x,x,<,, All
		StringReplace, x,x,|,, All
		StringReplace, x,x,@,, All
		StringReplace, x,x,`",, All
		StringReplace, x,x,|,, All
		StringReplace, x,x,:,, All
		
		Loop
		{
			StringReplace, x,x,__,_, UseErrorLevel
			if (ErrorLevel = 0) 
				break
		}
		
		Loop
		{
			StringReplace, x,x,_-_,-, UseErrorLevel
			if (ErrorLevel = 0) 
				break
		}
		
		Loop
		{
			StringReplace, x,x,--,-, UseErrorLevel
			if (ErrorLevel = 0) 
				break
		}
	}
	
	return x
}


; функция транслитерации из молдавской кирилицы на румынскую латиницу
TransliterateMD( x, replSpace )
{	
	StringReplace, x, x, ӂия , gia , All
	StringReplace, x, x, Ӂия , Gia , All
	StringReplace, x, x, ӁИЯ , GIA , All
	
	StringReplace, x, x, ӂа , gea , All
	StringReplace, x, x, Ӂа , Gea , All
	StringReplace, x, x, ӁА , GEA , All
	
	StringReplace, x, x, ӂо , gio , All
	StringReplace, x, x, Ӂо , Gio , All
	StringReplace, x, x, ӁО , GIO , All
	
	StringReplace, x, x, ӂу , giu , All
	StringReplace, x, x, Ӂу , Giu , All
	StringReplace, x, x, ӁУ , GIU , All
	
	StringReplace, x, x, ия , ia , All
	StringReplace, x, x, Ия , Ia , All
	StringReplace, x, x, ИЯ , IA , All
	
	StringReplace, x, x, ья , ia , All
	StringReplace, x, x, Ья , Ia , All
	StringReplace, x, x, ЬЯ , IA , All
	
	
	x := RegExReplace(x, "m)([^а-яА-ЯӂӁa-zA-Z])Е", "$1Ie")
	x := RegExReplace(x, "m)([^а-яА-ЯӂӁa-zA-Z])е", "$1ie")
	x := RegExReplace(x, "m)^Е", "Ie")
	x := RegExReplace(x, "m)^е", "ie")
	x := RegExReplace(x, "m)([аеиоуэыАЕИОУЭЫ])Е", "$1Ie")
	x := RegExReplace(x, "m)([аеиоуэыАЕИОУЭЫ])е", "$1ie")
	
	StringReplace, x, x, ги , ghi , All
	StringReplace, x, x, гь , ghi , All
	StringReplace, x, x, гй , ghi , All
	StringReplace, x, x, ге , ghe , All
	
	StringReplace, x, x, Ги , Ghi , All
	StringReplace, x, x, Гь , Ghi , All
	StringReplace, x, x, Гй , Ghi , All
	StringReplace, x, x, Ге , Ghe , All
	
	StringReplace, x, x, ГИ , GHI , All
	StringReplace, x, x, ГЬ , GHI , All
	StringReplace, x, x, ГЙ , GHI , All
	StringReplace, x, x, ГЕ , GHE , All	
	
	
	StringReplace, x, x, чиа , cia , All
	StringReplace, x, x, чо , cio , All
	StringReplace, x, x, чу , ciu , All
	StringReplace, x, x, ча , cea , All
	
	StringReplace, x, x, Чиа , Cia , All
	StringReplace, x, x, Чо , Cio , All
	StringReplace, x, x, Чу , Ciu , All
	StringReplace, x, x, Ча , Cea , All
	
	StringReplace, x, x, ЧИА , CIA , All
	StringReplace, x, x, ЧО , CIO , All
	StringReplace, x, x, ЧУ , CIU , All
	StringReplace, x, x, ЧА , CEA , All
	
	StringReplace, x, x, ке , che , All
	StringReplace, x, x, ки , chi , All
	
	StringReplace, x, x, Ке , Che , All
	StringReplace, x, x, Ки , Chi , All
	
	StringReplace, x, x, КЕ , CHE , All
	StringReplace, x, x, КИ , CHI , All
	
	StringReplace, x, x, кс , x , All
	StringReplace, x, x, кз , x , All
	
	StringReplace, x, x, Кс , X , All
	StringReplace, x, x, Кз , X , All
	
	StringReplace, x, x, КС , X , All
	StringReplace, x, x, КЗ , X , All
	
	StringReplace, x, x, ея , eea , All
	StringReplace, x, x, Ея , Eea , All
	StringReplace, x, x, ЕЯ , EEA , All
	; е англ и русское бывает !!!
	StringReplace, x, x, eя , eea , All
	StringReplace, x, x, Eя , Eea , All
	StringReplace, x, x, EЯ , EEA , All	
	
	; замена на конце слова ч на ci
	x := RegExReplace(x, "m)ч$", "ci")
	x := RegExReplace(x, "m)Ч$", "CI")
	x := RegExReplace(x, "m)ч([^а-яА-ЯӂӁa-zA-Z])", "ci$1")
	x := RegExReplace(x, "m)Ч([^а-яА-ЯӂӁa-zA-Z])", "CI$1")
		
	; замена на конце слова ии на iii
	x := RegExReplace(x, "m)iи$", "iii")
	x := RegExReplace(x, "m)IИ$", "III")
	x := RegExReplace(x, "m)iи([^а-яА-ЯӂӁa-zA-Z])", "iii$1")
	x := RegExReplace(x, "m)IИ([^а-яА-ЯӂӁa-zA-Z])", "III$1")
	x := RegExReplace(x, "m)ии$", "iii")
	x := RegExReplace(x, "m)ИИ$", "III")
	x := RegExReplace(x, "m)ии([^а-яА-ЯӂӁa-zA-Z])", "iii$1")
	x := RegExReplace(x, "m)ИИ([^а-яА-ЯӂӁa-zA-Z])", "III$1")
	
	
	; замены от А до Я
	; для упрощения Ы всегда на Î (так как возможно после приставок и как бы в середине слова получится)
	; Я всегда EA 
	StringReplace, x, x, а , a , All
	StringReplace, x, x, А , A , All
	StringReplace, x, x, б , b , All
	StringReplace, x, x, Б , B , All
	StringReplace, x, x, в , v , All
	StringReplace, x, x, В , V , All
	StringReplace, x, x, г , g , All
	StringReplace, x, x, Г , G , All
	StringReplace, x, x, д , d , All
	StringReplace, x, x, Д , D , All
	StringReplace, x, x, е , e , All
	StringReplace, x, x, Е , E , All
	StringReplace, x, x, ж , j , All
	StringReplace, x, x, Ж , J , All
	StringReplace, x, x, ӂ , g , All
	StringReplace, x, x, Ӂ , g , All
	StringReplace, x, x, з , z , All
	StringReplace, x, x, З , Z , All
	StringReplace, x, x, и , i , All
	StringReplace, x, x, И , I , All
	StringReplace, x, x, й , i , All
	StringReplace, x, x, Й , I , All
	StringReplace, x, x, к , c , All
	StringReplace, x, x, К , C , All
	StringReplace, x, x, л , l , All
	StringReplace, x, x, Л , L , All
	StringReplace, x, x, м , m , All
	StringReplace, x, x, М , M , All
	StringReplace, x, x, н , n , All
	StringReplace, x, x, Н , N , All
	StringReplace, x, x, о , o , All
	StringReplace, x, x, О , O , All
	StringReplace, x, x, п , p , All
	StringReplace, x, x, П , P , All
	StringReplace, x, x, р , r , All
	StringReplace, x, x, Р , R , All
	StringReplace, x, x, с , s , All
	StringReplace, x, x, С , S , All
	StringReplace, x, x, т , t , All
	StringReplace, x, x, Т , T , All
	StringReplace, x, x, у , u , All
	StringReplace, x, x, У , U , All
	StringReplace, x, x, ф , f , All
	StringReplace, x, x, Ф , F , All
	StringReplace, x, x, х , h , All
	StringReplace, x, x, Х , H , All
	StringReplace, x, x, ц , ț , All
	StringReplace, x, x, Ц , Ț , All
	StringReplace, x, x, ч , c , All
	StringReplace, x, x, Ч , C , All
	StringReplace, x, x, ш , ș , All
	StringReplace, x, x, Ш , Ș , All
	StringReplace, x, x, ы , î , All
	StringReplace, x, x, Ы , Î , All
	StringReplace, x, x, ь , i , All
	StringReplace, x, x, Ь , I , All
	StringReplace, x, x, э , ă , All
	StringReplace, x, x, Э , Ă , All
	StringReplace, x, x, ю , iu , All
	StringReplace, x, x, Ю , Iu , All
	StringReplace, x, x, я , ea , All
	StringReplace, x, x, Я , Ea , All	
		
	
	; замена пробела и др. символов для сохранения в именах файлов - ПОКА НЕ ИСПОЛЬЗУЕТСЯ !!!!!!!!
	if(replSpace) 
	{
		StringReplace, x,x,%A_Space%,_, All	; пробел заменить _				
		StringReplace, x,x,№,N, All
		StringReplace, x,x,`%,, All
		StringReplace, x,x,`,,_, All
		StringReplace, x,x,!,, All
		StringReplace, x,x,?,, All
		StringReplace, x,x,~,, All
		StringReplace, x,x,/,_, All
		StringReplace, x,x,*,, All
		StringReplace, x,x,>,, All
		StringReplace, x,x,<,, All
		StringReplace, x,x,|,, All
		StringReplace, x,x,@,, All
		StringReplace, x,x,`",, All
		StringReplace, x,x,|,, All
		StringReplace, x,x,:,, All
		
		Loop
		{
			StringReplace, x,x,__,_, UseErrorLevel
			if (ErrorLevel = 0) 
				break
		}
		
		Loop
		{
			StringReplace, x,x,_-_,-, UseErrorLevel
			if (ErrorLevel = 0) 
				break
		}
		
		Loop
		{
			StringReplace, x,x,--,-, UseErrorLevel
			if (ErrorLevel = 0) 
				break
		}
	}
	
	

	return x
}


; Транслитерация выделенного текста по Alt+ScrollLock
;   Alt+Shift+ScrollLock транслит для имен файлов
;   Alt+Win+ScrollLock транслит молдавской кирилицы
Alt & ScrollLock::	
	Critical ; критическая секция кода
	
	Clipboard := ""
	if (not GetKeyState("Shift")) and (not GetKeyState("LWin"))
	{
		Send ^{Insert}
		ClipWait 2
		Clipboard := Transliterate( Clipboard, 0 )
	}
	else
	{
		if not GetKeyState("LWin")
		{
			Send ^{Insert}
			ClipWait 2
			Clipboard := Transliterate( Clipboard, 1 )
		}
		else
		{
			Send ^{Insert}
			ClipWait 2
			Clipboard := TransliterateMD( Clipboard, 0 )
		}
	}  
    
	Send {Del}
	Sleep 200
	Send ^{v}
	
	Critical OFF ; отключение критической секции
	Sleep -1 ; Critical точно отработал
	
return


; Вставка текста без форматирования по Ctrl+Alt+V
$^!v::	
	Critical ; критическая секция кода
	
	ClipSaved := ClipboardAll ; сохраняем, что есть в буфере
	Clipboard = %Clipboard%  ; удаляем форматирование	
	Send ^{v} ; вставляем
	Sleep 200
	Clipboard := ClipSaved ; возврат в буфер сохраненного
	; очистим переменную освободив память
	ClipSaved = 
	
	Critical OFF ; отключение критической секции
	Sleep -1 ; Critical точно отработал
Return


; изменить регистр на нижний
Alt & Pause::	
	Critical ; критическая секция кода
	
	Clipboard := ""
	if not GetKeyState("Shift")
	{
		Send ^{Insert}
		ClipWait 2		
		StringLower, ClipBoard , ClipBoard
	}
	else
	{
		Send ^{Insert}
		ClipWait 2
		StringUpper, ClipBoard , ClipBoard
	}  
    
	Send {Del}
	Sleep 200
	Send ^{v}
	
	Critical OFF ; отключение критической секции
	Sleep -1 ; Critical точно отработал

return

